/*
Copyright 2021 The Kruise Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	scheme "github.com/openkruise/kruise-api/client/clientset/versioned/scheme"
	v1alpha1 "github.com/openkruise/kruise-api/policy/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// PodUnavailableBudgetsGetter has a method to return a PodUnavailableBudgetInterface.
// A group's client should implement this interface.
type PodUnavailableBudgetsGetter interface {
	PodUnavailableBudgets(namespace string) PodUnavailableBudgetInterface
}

// PodUnavailableBudgetInterface has methods to work with PodUnavailableBudget resources.
type PodUnavailableBudgetInterface interface {
	Create(*v1alpha1.PodUnavailableBudget) (*v1alpha1.PodUnavailableBudget, error)
	Update(*v1alpha1.PodUnavailableBudget) (*v1alpha1.PodUnavailableBudget, error)
	UpdateStatus(*v1alpha1.PodUnavailableBudget) (*v1alpha1.PodUnavailableBudget, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.PodUnavailableBudget, error)
	List(opts v1.ListOptions) (*v1alpha1.PodUnavailableBudgetList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.PodUnavailableBudget, err error)
	PodUnavailableBudgetExpansion
}

// podUnavailableBudgets implements PodUnavailableBudgetInterface
type podUnavailableBudgets struct {
	client rest.Interface
	ns     string
}

// newPodUnavailableBudgets returns a PodUnavailableBudgets
func newPodUnavailableBudgets(c *PolicyV1alpha1Client, namespace string) *podUnavailableBudgets {
	return &podUnavailableBudgets{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the podUnavailableBudget, and returns the corresponding podUnavailableBudget object, and an error if there is any.
func (c *podUnavailableBudgets) Get(name string, options v1.GetOptions) (result *v1alpha1.PodUnavailableBudget, err error) {
	result = &v1alpha1.PodUnavailableBudget{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of PodUnavailableBudgets that match those selectors.
func (c *podUnavailableBudgets) List(opts v1.ListOptions) (result *v1alpha1.PodUnavailableBudgetList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.PodUnavailableBudgetList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested podUnavailableBudgets.
func (c *podUnavailableBudgets) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a podUnavailableBudget and creates it.  Returns the server's representation of the podUnavailableBudget, and an error, if there is any.
func (c *podUnavailableBudgets) Create(podUnavailableBudget *v1alpha1.PodUnavailableBudget) (result *v1alpha1.PodUnavailableBudget, err error) {
	result = &v1alpha1.PodUnavailableBudget{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		Body(podUnavailableBudget).
		Do().
		Into(result)
	return
}

// Update takes the representation of a podUnavailableBudget and updates it. Returns the server's representation of the podUnavailableBudget, and an error, if there is any.
func (c *podUnavailableBudgets) Update(podUnavailableBudget *v1alpha1.PodUnavailableBudget) (result *v1alpha1.PodUnavailableBudget, err error) {
	result = &v1alpha1.PodUnavailableBudget{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		Name(podUnavailableBudget.Name).
		Body(podUnavailableBudget).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *podUnavailableBudgets) UpdateStatus(podUnavailableBudget *v1alpha1.PodUnavailableBudget) (result *v1alpha1.PodUnavailableBudget, err error) {
	result = &v1alpha1.PodUnavailableBudget{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		Name(podUnavailableBudget.Name).
		SubResource("status").
		Body(podUnavailableBudget).
		Do().
		Into(result)
	return
}

// Delete takes name of the podUnavailableBudget and deletes it. Returns an error if one occurs.
func (c *podUnavailableBudgets) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *podUnavailableBudgets) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched podUnavailableBudget.
func (c *podUnavailableBudgets) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.PodUnavailableBudget, err error) {
	result = &v1alpha1.PodUnavailableBudget{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("podunavailablebudgets").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
